<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use \Zeedhi\Framework\DTO\Request\Row;
use Teknisa\MAN\Service;

class ParametrosVenda extends \Zeedhi\Framework\Controller\Simple {

	protected $paramVendaService;
	protected $instanceManager;
	protected $produtoService;

	public function __construct(Services\ParametrosVenda $paramVendaService, \Zeedhi\Framework\DependencyInjection\InstanceManager $instanceManager, Services\ProdutoService $produtoService) {
		$this->paramVendaService   = $paramVendaService;
		$this->instanceManager   = $instanceManager;
		$this->produtoService = $produtoService;
	}

	public function getAllvndparametros(Request\Filter $request, Response $response){
		$conditions = $request->getFilterCriteria()->getConditions();
		$parametros = $this->paramVendaService->getParametros();
		$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('GetAllvndparametros', $parametros));
	}

	public function getAllHierarquiaparametros(Row $params, Response $response){
		$array = $params->getRow();
		$nrorg    = $array["nrorg"];
		$parametros = $this->paramVendaService->getHierarquiaParametros($nrorg);
		$opcaoparam = $this->paramVendaService->getOpcaoParametro();
		$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet ('GetAllOpcaoParametros', array($opcaoparam)));
		$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet ('GetAllHierarquiaparametros', array($parametros)));
	}
	
	public function getParamValueByParam(Request\Filter $request, Response $response){
		$retorno = $request->getFilterCriteria()->getConditions();
        $DESCRELACIONAMENTO = $retorno[1]['value'];
		if($DESCRELACIONAMENTO == 'GERAL'){
			$valor = $this->paramVendaService->getParamValueByParam($retorno);
        }elseif($DESCRELACIONAMENTO == 'FILILOJA'){
        	$valor = $this->paramVendaService->getParamValueFililoja($retorno);
        }elseif($DESCRELACIONAMENTO == 'TIPORECE'){
			$valor = $this->paramVendaService->getParamValueByParam($retorno);
        }elseif($DESCRELACIONAMENTO == 'CDFILIAL_TIPORECE'){
        	$valor = $this->paramVendaService->getParamValueFililoja($retorno);
        }elseif($DESCRELACIONAMENTO == 'CDLOJA_TIPORECE'){
        	$valor = $this->paramVendaService->getParamValueFililoja($retorno);
        }
        $parametros = array('PARAMETROV'=>$valor);

		$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('getParamValueByParam', array($parametros)));	
	}

	public function saveParamValue(Row $params, Response $response){
		$array = $params->getRow();
		$parametros = $this->paramVendaService->saveParamValue($array); 

	}

	public function getTiporece(Request\Filter $request, Response $response){
	    $retorno = $request->getFilterCriteria()->getConditions();
	 	$NRORG              = $retorno[2]['value'];
	    $params = array('NRORG'=>$NRORG);
		$parametros = $this->paramVendaService->getTiporece($params);
		$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('getTiporece', $parametros));	
	}  

	public function getTabelaParametros(Row $params, Response $response){
	 	$array = $params->getRow();
	 	
	 	$nrorg = $array["nrorg"];
	 	
	 	$params = array('NRORG'=>$nrorg);
	 	$tiporece     = $this->paramVendaService->getTiporece($params);
	 	$cliente      = $this->paramVendaService->getCliente($params);
	 	$formpgto     = $this->paramVendaService->getFormpgto($params);
	    $tipobaixarece= $this->paramVendaService->getTipoBaixaRece($params);
	    $cdpictprod = $this->produtoService->getCdpictprod($params);
	    $cdnvprod = $this->produtoService->getUltNvProd($params);
	 	
		$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('cliente', $cliente));
		$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('formpgto', $formpgto));
		$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('tipobaixarece', $tipobaixarece));
		$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('cdpictprod', $cdpictprod));
		$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('cdnvprod', $cdnvprod));
		
	}

}