<?php 

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;
use \Doctrine\ORM\EntityManager;


class ProdutividadeVendedorContinuo {
    
	protected $entityManager; 

	public function __construct(EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}

    private function setReportParameters(&$params, &$conditions) {
        $params = array(
            ':DATAINI' => isset($conditions['DATAINI']) ? $conditions['DATAINI'] : null ,
            ':DATAFIN' => isset($conditions['DATAFIN']) ? $conditions['DATAFIN'] : null ,
            ':CDFILIAL' => isset($conditions['CDFILIAL']) ? $conditions['CDFILIAL'] : null ,
            ':TCDFILIAL' => isset($conditions['TCDFILIAL']) ? $conditions['TCDFILIAL'] : null ,
            ':CDLOJA' => isset($conditions['CDLOJA']) ? $conditions['CDLOJA'] : null ,
            ':TCDLOJA' => isset($conditions['TCDLOJA']) ? $conditions['TCDLOJA'] : null ,
            ':CDVENDEDOR' => isset($conditions['CDVENDEDOR']) ? $conditions['CDVENDEDOR'] : null ,
            ':TCDVENDEDOR' => isset($conditions['TCDVENDEDOR']) ? $conditions['TCDVENDEDOR'] : null ,
            ':DTMOVTURCAIX' => isset($conditions['DTMOVTURCAIX']) ? $conditions['DTMOVTURCAIX'] : null ,
            ':TDTMOVTURCAIX' => isset($conditions['TDTMOVTURCAIX']) ? $conditions['TDTMOVTURCAIX'] : null ,
            ':NRORG' => $conditions['NRORG']
        );
    } 
    
    public function getProdutividadeVendedor($conditions) {
    	$params = [];
        $this->setReportParameters($params, $conditions);
        $qryPrincipal = $this->entityManager->getConnection()->fetchAll(self::REL_PRODUTIVIDADE_VENDEDOR_CONTINUO_OTIMIZADO, $params);
        return $qryPrincipal;
    }
  
  const REL_PRODUTIVIDADE_VENDEDOR_CONTINUO_OTIMIZADO ="
    
 SELECT  (CDFILIAL || ' - ' || NMFILIAL)||' - '||(CDLOJA || ' - ' || NMLOJA)  AS FILILOJA, VRREPIQUEVENDA AS VRREPIQUE,
           FINAL.CDVENDEDOR||' - '||FINAL.NMRAZSOCVEN AS NMRAZSOCVEN, FINAL.DTABERTUR, FINAL.NRINSJURVEN AS RAZAO,
               FINAL.VRREPITEM AS VRREPIQUEVENDA, FINAL.VRGORJETA, FINAL.QTPRODVEND AS QTDE, FINAL.DES, FINAL.ACR + FINAL.VRGORJETA AS ACRGORJ, FINAL.VRTXENTRVENDA AS VRTXENTREGA,
               FINAL.VRPRODVENDA + FINAL.VRREPITEM VRFINALITEM, (FINAL.VRPRODVENDA + FINAL.VRREPITEM) + FINAL.VRGORJETA AS VALOR_TOTAL, GOR AS ACR
          FROM
               (SELECT DISTINCT CONSOLIDADO.CDFILIAL, CONSOLIDADO.NMFILIAL, CONSOLIDADO.CDLOJA, CONSOLIDADO.NMLOJA, CONSOLIDADO.DTABERTUR, SUM(GOR) AS GOR,
                       CONSOLIDADO.CDVENDEDOR, CONSOLIDADO.NMRAZSOCVEN, CONSOLIDADO.NRINSJURVEN, TRUNC( NVL(SUM(((VRGORJETAVENDA - VRREPIQUEVENDA) * VRPRODVENDA)/ VRGERALITEMVENDA), 0), 2) VRGORJETA, 
                       SUM(QTPRODVEND) QTPRODVEND, SUM(ACR) ACR, SUM(DES) DES, SUM(VRPRODVENDA) VRPRODVENDA, TRUNC(SUM(VRREPITEMTEMP / VRGERALITEMVENDA),2) AS VRREPITEM, NVL(SUM(VRREPIQUEVENDA),0) AS VRREPIQUEVENDA, SUM(VRTXENTRVENDA) AS VRTXENTRVENDA
                  FROM
                       (SELECT DISTINCT RELATORIO.CDFILIAL, RELATORIO.NMFILIAL, RELATORIO.CDLOJA, RELATORIO.NMLOJA, RELATORIO.CDVENDEDOR,
                               RELATORIO.NMRAZSOCVEN, RELATORIO.NRINSJURVEN, RELATORIO.NRSEQVENDA, RELATORIO.DTABERTUR, NVL(RELATORIO.VRREPIQUEVENDA, 0) VRREPIQUEVENDA, SUM(RELATORIO.QTPRODVEND) QTPRODVEND,
                               SUM(RELATORIO.ACR) ACR, SUM(RELATORIO.DES) DES, SUM(RELATORIO.VRPRODVENDA) VRPRODVENDA, SUM(RELATORIO.VRGORJETA) VRGORJETAVENDA, SUM(RELATORIO.VRTXENTR) VRTXENTRVENDA,
                               NVL(SUM(RELATORIO.VRREPIQUEVENDA * RELATORIO.VRPRODVENDA), 0) VRREPITEMTEMP, SUM(RELATORIO.VRITENS) VRGERALITEMVENDA, GOR
                          FROM
                               (SELECT DISTINCT DADOSITEM.CDFILIAL, DADOSITEM.NMFILIAL, DADOSITEM.CDLOJA, DADOSITEM.NMLOJA, DADOSITEM.CDVENDEDOR,
                                       DADOSITEM.NMRAZSOCVEN, DADOSITEM.NRINSJURVEN, DADOSITEM.QTPRODVEND, DADOSITEM.ACR, DADOSITEM.DES, DADOSITEM.VRPRODVENDA, DADOSITEM.VRREPIQUEVENDA,
                                       DADOSITEM.NRSEQVENDA, VRITENS, VRGORJETA, NVL(VRTXENTR, 0 ) AS VRTXENTR, DADOSITEM.DTABERTUR, GOR
                                  FROM
                                       (SELECT DISTINCT FILTROREL.CDFILIAL, FILTROREL.NMFILIAL, FILTROREL.CDLOJA, FILTROREL.NMLOJA, FILTROREL.CDVENDEDOR,
                                               FILTROREL.CDPRODTAXASERV, FILTROREL.CDPRODTAXAENTR, FILTROREL.NMRAZSOCVEN, FILTROREL.NRINSJURVEN, FILTROREL.CDCAIXA, FILTROREL.VRREPIQUEVENDA, FILTROREL.QTPRODVEND,
                                               FILTROREL.ACR, FILTROREL.DES, FILTROREL.VRPRODVENDA, FILTROREL.NRSEQVENDA, ITEMVEND.DTABERTUR
                                          FROM
                                               (SELECT DISTINCT FILTROVENDA.CDFILIAL, FILTROVENDA.NMFILIAL, FILTROVENDA.CDLOJA, FILTROVENDA.NMLOJA, FILTROVENDA.CDVENDEDOR AS CDVENDEDOR,
                                                       FILTROVENDA.NRSEQVENDA, FILTROVENDA.CDPRODTAXASERV, FILTROVENDA.CDPRODTAXAENTR, FILTROVENDA.CDCAIXA, V.NMRAZSOCVEN, V.NRINSJURVEN, FILTROVENDA.VRREPIQUEVENDA, FILTROVENDA.DTABERTUR,
                                                       SUM(I.QTPRODVEND) QTPRODVEND, SUM(I.VRACRITVEND) ACR, SUM(I.VRDESITVEND) DES, 
                                                       SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRPRODVENDA
                                                  FROM
                                                       (SELECT DISTINCT CDVENDEDOR, NMRAZSOCVEN, NRINSJURVEN
                                                          FROM VENDEDOR
                                                         WHERE ((INSTR(:CDVENDEDOR, CDVENDEDOR) > 0) OR (:TCDVENDEDOR = 'T'))
                                                       ) V,
                                                       (SELECT DISTINCT VE.CDFILIAL, VE.CDCAIXA, VE.CDLOJA, VE.NRSEQVENDA, FILTROGER.CDFILIAL ||VE.CDCAIXA ||TO_DATE(VE.DTABERTUR, 'DD/MM/YYYY HH24:MI:SS') CHAVE,
                                                               TO_DATE(VE.DTABERTUR, 'DD/MM/YYYY HH24:MI:SS') AS DTABERTUR, VE.CDVENDEDOR, FILTROGER.CDPRODTAXASERV, FILTROGER.CDPRODTAXAENTR, FILTROGER.NMLOJA, FILTROGER.NMFILIAL, 
                                                               VE.VRREPIQUEVENDA
                                                          FROM VENDA VE,
                                                               (SELECT DISTINCT C.CDFILIAL, C.NMFILIAL, C.CDCAIXA, L.CDLOJA, L.NMLOJA, NVL(L.CDPRODTAXASERV, 'X') CDPRODTAXASERV, 
                                                                       NVL(L.CDPRODTAXAENTR, 'X') CDPRODTAXAENTR
                                                                  FROM LOJA L,
                                                                       (SELECT DISTINCT F.CDFILIAL, F.NMFILIAL, CX.CDCAIXA, CX.NMCAIXA, CX.CDLOJA
                                                                          FROM CAIXA CX,
                                                                               (SELECT DISTINCT CDFILIAL, NMFILIAL
                                                                                  FROM FILIAL
                                                                                 WHERE ((INSTR(:CDFILIAL, CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
                                                                               ) F
                                                                         WHERE CX.CDFILIAL = F.CDFILIAL
                                                                           AND (INSTR(:DTMOVTURCAIX, '_' ||F.CDFILIAL ||CDCAIXA) > 0 OR :TDTMOVTURCAIX = 'T') 
                                                                       ) C
                                                                 WHERE L.CDFILIAL = C.CDFILIAL
                                                                   AND L.CDLOJA     = C.CDLOJA
                                                                   AND ((INSTR(:CDLOJA, L.CDFILIAL ||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T')) 
                                                               ) FILTROGER
                                                         WHERE VE.IDSITUVENDA = 'O'
                                                           AND VE.CDFILIAL      = FILTROGER.CDFILIAL
                                                           AND VE.CDLOJA        = FILTROGER.CDLOJA
                                                           AND VE.CDCAIXA       = FILTROGER.CDCAIXA
                                                           AND VE.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                                                       ) FILTROVENDA, ITEMVENDA I
                                                 WHERE ((INSTR(:DTMOVTURCAIX, FILTROVENDA.CHAVE) > 0) OR (:TDTMOVTURCAIX = 'T'))
                                                   AND I.CDFILIAL = FILTROVENDA.CDFILIAL
                                                   AND I.CDCAIXA = FILTROVENDA.CDCAIXA
                                                   AND I.NRSEQVENDA = FILTROVENDA.NRSEQVENDA
                                                   AND FILTROVENDA.CDVENDEDOR   = V.CDVENDEDOR
                                                   AND I.CDPRODUTO NOT IN (FILTROVENDA.CDPRODTAXAENTR, FILTROVENDA.CDPRODTAXASERV)
                                                 GROUP BY FILTROVENDA.CDFILIAL, FILTROVENDA.NMFILIAL, FILTROVENDA.CDLOJA, FILTROVENDA.NMLOJA, FILTROVENDA.CDVENDEDOR,
                                                          FILTROVENDA.NRSEQVENDA, FILTROVENDA.CDPRODTAXASERV, FILTROVENDA.CDPRODTAXAENTR, FILTROVENDA.CDCAIXA, V.NMRAZSOCVEN, V.NRINSJURVEN, FILTROVENDA.VRREPIQUEVENDA,
                                                          FILTROVENDA.DTABERTUR
                                               ) FILTROREL,
                                               (SELECT DISTINCT V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, V.CDLOJA, I.VRUNITVEND, V.CDVENDEDOR AS CDVENDEDOR, TO_DATE(V.DTABERTUR, 'DD/MM/YYYY HH24:MI:SS') AS DTABERTUR, 
                                                       SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) VRPRODVEND
                                                  FROM ITEMVENDA I
                                                  JOIN (SELECT DISTINCT VE.CDFILIAL, VE.CDCAIXA, VE.CDLOJA, VE.NRSEQVENDA, VE.CDVENDEDOR, FILTROGER.CDPRODTAXASERV, FILTROGER.CDPRODTAXAENTR,
                                                               TO_DATE(VE.DTABERTUR, 'DD/MM/YYYY HH24:MI:SS') AS DTABERTUR
                                                          FROM VENDA VE
                                                          JOIN (SELECT DISTINCT C.CDFILIAL, C.CDCAIXA, L.CDLOJA, NVL(L.CDPRODTAXASERV, 'X') CDPRODTAXASERV, 
                                                                       NVL(L.CDPRODTAXAENTR, 'X') CDPRODTAXAENTR
                                                                  FROM LOJA L,
                                                                       (SELECT DISTINCT F.CDFILIAL, CX.CDCAIXA, CX.CDLOJA
                                                                          FROM CAIXA CX,
                                                                               (SELECT DISTINCT CDFILIAL
                                                                                  FROM FILIAL
                                                                                 WHERE ((INSTR(:CDFILIAL, CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
                                                                               ) F
                                                                         WHERE CX.CDFILIAL = F.CDFILIAL
                                                                           AND (INSTR(:DTMOVTURCAIX, '_' ||F.CDFILIAL ||CDCAIXA) > 0 OR :TDTMOVTURCAIX = 'T') 
                                                                       ) C
                                                                 WHERE L.CDFILIAL = C.CDFILIAL
                                                                   AND L.CDLOJA     = C.CDLOJA
                                                                   AND ((INSTR(:CDLOJA, L.CDFILIAL ||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T')) 
                                                               ) FILTROGER
                                                            ON VE.CDFILIAL      = FILTROGER.CDFILIAL
                                                           AND VE.CDLOJA        = FILTROGER.CDLOJA
                                                           AND VE.CDCAIXA       = FILTROGER.CDCAIXA
                                                         WHERE VE.IDSITUVENDA = 'O'
                                                           AND VE.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN ) V
                                                      ON I.CDFILIAL = V.CDFILIAL
                                                     AND I.CDCAIXA    = V.CDCAIXA
                                                     AND I.NRSEQVENDA = V.NRSEQVENDA
                                                   WHERE (V.CDVENDEDOR) IS NOT NULL
                                                     AND I.VRUNITVEND > 0
                                                     AND I.CDPRODUTO NOT IN (V.CDPRODTAXAENTR, V.CDPRODTAXASERV)
                                                   GROUP BY V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, V.CDLOJA, I.VRUNITVEND, V.CDVENDEDOR, V.DTABERTUR
                                               ) ITEMVEND
                                         WHERE ITEMVEND.CDFILIAL = FILTROREL.CDFILIAL
                                           AND ITEMVEND.NRSEQVENDA = FILTROREL.NRSEQVENDA
                                           AND ITEMVEND.CDLOJA     = FILTROREL.CDLOJA
                                           AND ITEMVEND.CDVENDEDOR = FILTROREL.CDVENDEDOR
                                           AND ITEMVEND.DTABERTUR  = FILTROREL.DTABERTUR
                                       ) DADOSITEM
                                  LEFT JOIN ( SELECT DISTINCT SUM(A.VRGORJETA) AS VRGORJETA, SUM(A.VRGORJETA) AS GOR, B.VRREPIQUEVENDA AS REPi,
                                                   A.CDFILIAL, A.NRSEQVENDA, A.CDCAIXA, TO_DATE(A.DTABERTUR, 'DD/MM/YYYY HH24:MI:SS') AS DTABERTUR, A.CDVENDEDOR
                                              FROM (SELECT DISTINCT V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, V.DTABERTUR, V.CDVENDEDOR AS CDVENDEDOR,
                                                           SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VALOR_TOTAL,
                                                           NVL(V.VRREPIQUEVENDA,0) AS VRREPIQUEVENDA 
                                                      FROM VENDA V, ITEMVENDA I, LOJA L, PRODUTO P
                                                     WHERE V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                                                       AND ((INSTR(:CDFILIAL, V.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
                                                       AND V.IDSITUVENDA = 'O'
                                                       AND V.CDFILIAL    = I.CDFILIAL
                                                       AND V.CDCAIXA     = I.CDCAIXA
                                                       AND V.NRSEQVENDA  = I.NRSEQVENDA
                                                       AND V.CDFILIAL    = L.CDFILIAL
                                                       AND V.CDLOJA      = L.CDLOJA
                                                       AND I.CDPRODUTO  <> NVL(L.CDPRODTAXASERV,'X')
                                                       AND I.CDPRODUTO  <> NVL(L.CDPRODTAXAENTR,'X')
                                                       AND P.CDPRODUTO   = I.CDPRODUTO
                                                       AND P.IDCOBTXSERV = 'S'
                                                     GROUP BY V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, V.VRREPIQUEVENDA, V.DTABERTUR, V.CDVENDEDOR )B,
                                                   (SELECT V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, V.DTABERTUR, V.CDVENDEDOR AS CDVENDEDOR,
                                                           SUM(NVL(I.VRACRITVEND,0)) AS VRGORJETA
                                                      FROM VENDA V, ITEMVENDA I, LOJA L
                                                     WHERE V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                                                       AND ((INSTR(:CDFILIAL, V.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
                                                       AND V.IDSITUVENDA = 'O'
                                                       AND V.CDFILIAL    = I.CDFILIAL
                                                       AND V.CDCAIXA     = I.CDCAIXA
                                                       AND V.NRSEQVENDA  = I.NRSEQVENDA
                                                       AND V.CDFILIAL    = L.CDFILIAL
                                                       AND V.CDLOJA      = L.CDLOJA
                                                       AND I.CDPRODUTO   = L.CDPRODTAXASERV
                                                     GROUP BY V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, V.DTABERTUR, V.CDVENDEDOR)A
                                            WHERE (A.CDFILIAL   = B.CDFILIAL (+)    ) 
                                              AND (A.CDCAIXA    = B.CDCAIXA  (+)    ) 
                                              AND (A.NRSEQVENDA  = B.NRSEQVENDA (+)  ) 
                                              AND (A.CDVENDEDOR  = B.CDVENDEDOR  (+) )
                                              GROUP BY A.CDFILIAL, A.NRSEQVENDA, A.CDCAIXA, TO_DATE(A.DTABERTUR, 'DD/MM/YYYY HH24:MI:SS'), B.VRREPIQUEVENDA,  A.CDVENDEDOR
                                              ) VALORGORJETA
                                          ON VALORGORJETA.CDFILIAL    = DADOSITEM.CDFILIAL
                                         AND VALORGORJETA.CDCAIXA    = DADOSITEM.CDCAIXA
                                         AND VALORGORJETA.NRSEQVENDA = DADOSITEM.NRSEQVENDA
                                         AND VALORGORJETA.CDVENDEDOR = DADOSITEM.CDVENDEDOR
                                         AND VALORGORJETA.DTABERTUR = DADOSITEM.DTABERTUR
                                         LEFT JOIN (SELECT V.CDFILIAL, V.NRSEQVENDA, V.CDCAIXA, SUM(NVL(I.VRACRITVEND,0)) VRTXENTR, TO_DATE(V.DTABERTUR, 'DD/MM/YYYY HH24:MI:SS') AS DTABERTUR
                                               FROM ITEMVENDA I, VENDA V, LOJA L
                                              WHERE I.CDFILIAL = V.CDFILIAL
                                                AND I.CDCAIXA    = V.CDCAIXA
                                                AND I.NRSEQVENDA = V.NRSEQVENDA
                                                AND V.CDLOJA     = L.CDLOJA
                                                AND I.CDLOJA     = L.CDLOJA
                                                AND V.CDFILIAL   = L.CDFILIAL
                                                AND I.CDPRODUTO IN (L.CDPRODTAXAENTR)
                                              GROUP BY V.CDFILIAL, V.NRSEQVENDA, V.CDCAIXA, V.DTABERTUR
                                            ) VALORTXENTR
                                      ON VALORTXENTR.CDFILIAL    = DADOSITEM.CDFILIAL
                                     AND VALORTXENTR.CDCAIXA    = DADOSITEM.CDCAIXA
                                     AND VALORTXENTR.NRSEQVENDA = DADOSITEM.NRSEQVENDA
                                     AND VALORTXENTR.DTABERTUR = DADOSITEM.DTABERTUR,
                     (SELECT V.CDFILIAL, V.NRSEQVENDA, V.CDCAIXA, TO_DATE(V.DTABERTUR, 'DD/MM/YYYY HH24:MI:SS') AS DTABERTUR, 
                               SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) VRITENS
                          FROM ITEMVENDA I
                          JOIN (SELECT DISTINCT VE.CDFILIAL, VE.CDCAIXA, VE.CDLOJA, VE.NRSEQVENDA, VE.CDVENDEDOR, FILTROGER.CDPRODTAXASERV, FILTROGER.CDPRODTAXAENTR,
                                                TO_DATE(VE.DTABERTUR, 'DD/MM/YYYY HH24:MI:SS') AS DTABERTUR
                                           FROM VENDA VE
                                           JOIN (SELECT DISTINCT C.CDFILIAL, C.CDCAIXA, L.CDLOJA, NVL(L.CDPRODTAXASERV, 'X') CDPRODTAXASERV, 
                                                        NVL(L.CDPRODTAXAENTR, 'X') CDPRODTAXAENTR
                                                   FROM LOJA L,
                                                        (SELECT DISTINCT F.CDFILIAL, CX.CDCAIXA, CX.CDLOJA
                                                           FROM CAIXA CX,
                                                                (SELECT DISTINCT CDFILIAL
                                                                   FROM FILIAL
                                                                  WHERE ((INSTR(:CDFILIAL, CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
                                                                ) F
                                                          WHERE CX.CDFILIAL = F.CDFILIAL
                                                            AND (INSTR(:DTMOVTURCAIX, '_' ||F.CDFILIAL ||CDCAIXA) > 0 OR :TDTMOVTURCAIX = 'T') 
                                                        ) C
                                                  WHERE L.CDFILIAL = C.CDFILIAL
                                                    AND L.CDLOJA     = C.CDLOJA
                                                    AND ((INSTR(:CDLOJA, L.CDFILIAL ||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T')) 
                                                ) FILTROGER
                                             ON VE.CDFILIAL      = FILTROGER.CDFILIAL
                                            AND VE.CDLOJA        = FILTROGER.CDLOJA
                                            AND VE.CDCAIXA       = FILTROGER.CDCAIXA
                                          WHERE VE.IDSITUVENDA = 'O' 
                                            AND VE.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN ) V
                            ON I.CDFILIAL = V.CDFILIAL
                           AND I.CDCAIXA    = V.CDCAIXA
                           AND I.NRSEQVENDA = V.NRSEQVENDA
                           AND I.CDLOJA     = V.CDLOJA
                         GROUP BY V.CDFILIAL, V.NRSEQVENDA, V.CDCAIXA, V.DTABERTUR
                      ) VALORGERALVENDA
                WHERE VALORGERALVENDA.CDFILIAL = DADOSITEM.CDFILIAL
                  AND VALORGERALVENDA.CDCAIXA    = DADOSITEM.CDCAIXA
                  AND VALORGERALVENDA.NRSEQVENDA = DADOSITEM.NRSEQVENDA
                 AND VALORGERALVENDA.DTABERTUR = DADOSITEM.DTABERTUR
                  ) RELATORIO
            GROUP BY RELATORIO.CDFILIAL, RELATORIO.NMFILIAL, RELATORIO.CDLOJA, RELATORIO.NMLOJA, RELATORIO.CDVENDEDOR, RELATORIO.NMRAZSOCVEN, RELATORIO.NRINSJURVEN,
                     RELATORIO.NRSEQVENDA, NVL(RELATORIO.VRREPIQUEVENDA, 0), RELATORIO.DTABERTUR, GOR
               ) CONSOLIDADO
           GROUP BY CONSOLIDADO.CDFILIAL, CONSOLIDADO.NMFILIAL, CONSOLIDADO.CDLOJA, CONSOLIDADO.NMLOJA, CONSOLIDADO.CDVENDEDOR,
                    CONSOLIDADO.NMRAZSOCVEN, CONSOLIDADO.NRINSJURVEN, CONSOLIDADO.DTABERTUR
              ) FINAL
        ORDER BY FINAL.CDFILIAL, FINAL.NMLOJA, FINAL.DTABERTUR, FINAL.CDVENDEDOR, FINAL.NMRAZSOCVEN
  "; 
}