<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;

class RelDecontosTipoConsumiService {

	public function __construct(EntityManager $entityManager) {
      $this->entityManager = $entityManager;
  }
  
  public function getDescConsuSint($conditions) {
    $params = array(
      ':CDFILIAL' => $conditions['CDFILIAL'],
      ':TCDFILIAL' => $conditions['TCDFILIAL'],
      ':NRORG' => $conditions['NRORG'],
      ':DTVENDAINI' => $conditions['DTVENDAINI'],
      ':DTVENDAFIN' => $conditions['DTVENDAFIN'],
      ':CDCLIENTE' => $conditions['CDCLIENTE'],
      ':TCDCLIENTE' => $conditions['TCDCLIENTE'],
      ':CDCONSUMIDOR' => $conditions['CDCONSUMIDOR'],
      ':TCDCONSUMIDOR' => $conditions['TCDCONSUMIDOR'],
      ':CDTIPOCONS' => $conditions['CDTIPOCONS'],
      ':TCDTIPOCONS' => $conditions['TCDTIPOCONS']
    );
    return $this->entityManager->getConnection()->fetchAll(self::GET_DESC_CONCE_CONSU_SINT, $params);
  }
  
  public function getDescConsuAnali($conditions) {
    $params = array(
      ':CDFILIAL' => $conditions['CDFILIAL'],
      ':TCDFILIAL' => $conditions['TCDFILIAL'],
      ':NRORG' => $conditions['NRORG'],
      ':DTVENDAINI' => $conditions['DTVENDAINI'],
      ':DTVENDAFIN' => $conditions['DTVENDAFIN'],
      ':CDCLIENTE' => $conditions['CDCLIENTE'],
      ':TCDCLIENTE' => $conditions['TCDCLIENTE'],
      ':CDCONSUMIDOR' => $conditions['CDCONSUMIDOR'],
      ':TCDCONSUMIDOR' => $conditions['TCDCONSUMIDOR'],
      ':CDTIPOCONS' => $conditions['CDTIPOCONS'],
      ':TCDTIPOCONS' => $conditions['TCDTIPOCONS']
 		);
 		return $this->entityManager->getConnection()->fetchAll(self::GET_DESC_CONCE_CONSU_ANALI, $params);
  }
    
  const GET_DESC_CONCE_CONSU_SINT = "
    SELECT FILOCAVECOTI.IDSITUVENDA, :CDFILIAL AS CDFILIALFILT, 'TODAS' AS LABELFILIAL,
           FILOCAVECOTI.CDCLIENTE, FILOCAVECOTI.CDCONSUMIDOR, FILOCAVECOTI.NRORG, FILOCAVECOTI.CDTIPOCONS, FILOCAVECOTI.NMCONSUMIDOR, 
           FILOCAVECOTI.NMTIPOCONS, P.CDARVPROD, I.CDPRODUTO, P.NMPRODUTO,
           FILOCAVECOTI.CDTIPOCONS||' - '||FILOCAVECOTI.NMTIPOCONS AS LABELTIPOCONS,
           P3.CDARVPROD AS CDARVPRODP3, P3.CDPRODUTO AS CDPRODUTOP3, P3.NMPRODUTO AS NMPRODUTOP3,
           FILOCAVECOTI.CDCONSUMIDOR||' - '||FILOCAVECOTI.NMCONSUMIDOR AS LABELCONSUMIDOR,
           P3.CDARVPROD||' - '||P.NMPRODUTO AS LABELPRODUTO,
           I.CDSUPERVDESC AS CDSUPERVISOR, OP.NMOPERADOR AS NMSUPERVISOR, OP.NMOPERADOR AS LABELSUPEVISOR,
           I.CDVENDEDOR, VD.NMRAZSOCVEN AS NMVENDEDOR, VD.NMRAZSOCVEN AS LABEELVENDEDOR, TO_CHAR(FILOCAVECOTI.DTENTRVENDA, 'DD/MM/YYYY') AS DTENTRVENDA,
           SUM(NVL(I.VRDESITVEND, 0)) AS DESCONTO, SUM(I.QTPRODVEND)  AS QTDE,
           SUM(TRUNC((I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0))) + NVL(I.VRACRITVEND,0),2)) AS VALOR_TOTAL,
           SUM(TRUNC((I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0))) + NVL(I.VRACRITVEND,0) - NVL(I.VRDESITVEND, 0),2)) AS VALOR_VENDIDO
      FROM ITEMVENDA I
      JOIN PRODUTO P
      ON I.CDPRODUTO = P.CDPRODUTO
       AND I.NRORG = P.NRORG
      LEFT JOIN VENDEDOR VD
        ON I.CDVENDEDOR = VD.CDVENDEDOR
       AND I.NRORG = VD.NRORG
      LEFT JOIN OPERADOR OP
        ON I.CDSUPERVDESC = OP.CDOPERADOR
       AND I.NRORG = OP.NRORG
      LEFT JOIN PRODUTO P4
        ON P.CDPRODNIVANTE = P4.CDPRODUTO
       AND P.NRORG = P4.NRORG
      LEFT JOIN PRODUTO P3
        ON P4.CDPRODNIVANTE = P3.CDPRODUTO
       AND P4.NRORG = P3.NRORG
      JOIN (SELECT FILOCAVECO.IDSITUVENDA, FILOCAVECO.NRSEQVENDA, FILOCAVECO.CDCAIXA, FILOCAVECO.NMCAIXA, FILOCAVECO.CDLOJA, FILOCAVECO.NMLOJA, FILOCAVECO.CDFILIAL, FILOCAVECO.CDCONSUMIDOR,
                 FILOCAVECO.NMFILIAL, FILOCAVECO.NRORG, FILOCAVECO.CDPRODTAXASERV, FILOCAVECO.CDTIPOCONS, FILOCAVECO.NMCONSUMIDOR, TC.NMTIPOCONS, FILOCAVECO.DTENTRVENDA, FILOCAVECO.CDCLIENTE
          FROM TIPOCONS TC
          JOIN ( SELECT FILOCAVE.IDSITUVENDA, FILOCAVE.NRSEQVENDA, FILOCAVE.CDCAIXA, FILOCAVE.NMCAIXA, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, FILOCAVE.CDFILIAL, FILOCAVE.CDCONSUMIDOR,
                      FILOCAVE.NMFILIAL, FILOCAVE.NRORG, FILOCAVE.CDPRODTAXASERV, C.CDTIPOCONS, C.NMCONSUMIDOR, FILOCAVE.DTENTRVENDA, FILOCAVE.CDCLIENTE
                   FROM CONSUMIDOR C
                   JOIN (SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, V.CDCONSUMIDOR,
                              FILOCA.NMFILIAL, FILOCA.NRORG, FILOCA.CDPRODTAXASERV, V.DTENTRVENDA, V.CDCLIENTE
                     FROM VENDA V
                     JOIN ( SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG, FILO.CDPRODTAXASERV
                      FROM CAIXA C
                      JOIN ( SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG, L.CDPRODTAXASERV
                           FROM LOJA L
                           JOIN ( SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
                                FROM FILIAL F
                                   WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0) OR (:TCDFILIAL = 'T'))
                                 AND F.NRORG = :NRORG ) FI
                             ON L.CDFILIAL = FI.CDFILIAL
                              AND L.NRORG = FI.NRORG ) FILO
                        ON C.CDFILIAL = FILO.CDFILIAL
                       AND C.CDLOJA = FILO.CDLOJA
                       AND C.NRORG = FILO.NRORG ) FILOCA
                   ON V.CDCAIXA = FILOCA.CDCAIXA
                  AND V.CDLOJA = FILOCA.CDLOJA
                  AND V.CDFILIAL = FILOCA.CDFILIAL
                  AND V.NRORG = FILOCA.NRORG
                    WHERE V.IDSITUVENDA = 'O'
                  AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
                            AND  V.CDCONSUMIDOR IS NOT NULL
                  AND ((INSTR(:CDCLIENTE, V.CDFILIAL||V.CDCLIENTE ) <> 0) OR (:TCDCLIENTE = 'T'))
                  AND ((INSTR(:CDCONSUMIDOR , '_'||V.CDCLIENTE ||V.CDCONSUMIDOR ||'_') <> 0 ) OR (:TCDCONSUMIDOR = 'T'))
                    ) FILOCAVE
                     ON FILOCAVE.CDCONSUMIDOR = C.CDCONSUMIDOR
                    AND FILOCAVE.CDCLIENTE = C.CDCLIENTE
                    AND FILOCAVE.NRORG = C.NRORG
                  WHERE ((INSTR(:CDCLIENTE, FILOCAVE.CDFILIAL||C.CDCLIENTE ) <> 0) OR (:TCDCLIENTE = 'T'))
                AND ((INSTR(:CDCONSUMIDOR , '_'||C.CDCLIENTE ||C.CDCONSUMIDOR ||'_') <> 0 ) OR (:TCDCONSUMIDOR = 'T'))
                AND ((INSTR(:CDTIPOCONS , C.CDTIPOCONS) <> 0 ) OR (:TCDTIPOCONS = 'T'))
                   ) FILOCAVECO
            ON FILOCAVECO.CDTIPOCONS = TC.CDTIPOCONS
               AND FILOCAVECO.NRORG = TC.NRORG
           WHERE ((INSTR(:CDTIPOCONS , TC.CDTIPOCONS) <> 0 ) OR (:TCDTIPOCONS = 'T'))
           ) FILOCAVECOTI
        ON I.NRSEQVENDA = FILOCAVECOTI.NRSEQVENDA
       AND I.CDFILIAL = FILOCAVECOTI.CDFILIAL
       AND I.CDCAIXA = FILOCAVECOTI.CDCAIXA
       AND I.NRORG = FILOCAVECOTI.NRORG
     WHERE I.VRDESITVEND <> '0'
     GROUP BY FILOCAVECOTI.IDSITUVENDA, FILOCAVECOTI.CDCONSUMIDOR, FILOCAVECOTI.NRORG, FILOCAVECOTI.CDTIPOCONS, FILOCAVECOTI.NMCONSUMIDOR, 
              FILOCAVECOTI.NMTIPOCONS, P.CDARVPROD, I.CDPRODUTO, P.NMPRODUTO, FILOCAVECOTI.CDCLIENTE,
              P3.CDARVPROD, P3.CDPRODUTO, P3.NMPRODUTO, I.CDSUPERVDESC, OP.NMOPERADOR, OP.NMOPERADOR,
              I.CDVENDEDOR, VD.NMRAZSOCVEN, VD.NMRAZSOCVEN, TO_CHAR(FILOCAVECOTI.DTENTRVENDA, 'DD/MM/YYYY')
  ";
    
  const GET_DESC_CONCE_CONSU_ANALI = "
    SELECT FILOCAVECOTI.IDSITUVENDA, FILOCAVECOTI.NRSEQVENDA, FILOCAVECOTI.CDCAIXA, FILOCAVECOTI.NMCAIXA, FILOCAVECOTI.CDLOJA, FILOCAVECOTI.NMLOJA, FILOCAVECOTI.CDFILIAL, 
           FILOCAVECOTI.CDCONSUMIDOR, FILOCAVECOTI.NMFILIAL, FILOCAVECOTI.NRORG, FILOCAVECOTI.CDPRODTAXASERV, FILOCAVECOTI.CDTIPOCONS, FILOCAVECOTI.NMCONSUMIDOR, 
           FILOCAVECOTI.NMTIPOCONS, P.CDARVPROD, I.CDPRODUTO, P.NMPRODUTO, FILOCAVECOTI.CDCLIENTE,
           FILOCAVECOTI.CDTIPOCONS||' - '||FILOCAVECOTI.NMTIPOCONS AS LABELTIPOCONS,
           FILOCAVECOTI.CDFILIAL||' - '||FILOCAVECOTI.NMFILIAL AS LABELFILIAL,
           P3.CDARVPROD AS CDARVPRODP3, P3.CDPRODUTO AS CDPRODUTOP3, P3.NMPRODUTO AS NMPRODUTOP3,
           FILOCAVECOTI.CDCONSUMIDOR||' - '||FILOCAVECOTI.NMCONSUMIDOR AS LABELCONSUMIDOR,
           P3.CDARVPROD||' - '||P.NMPRODUTO AS LABELPRODUTO,
           I.CDSUPERVDESC AS CDSUPERVISOR, OP.NMOPERADOR AS NMSUPERVISOR, OP.NMOPERADOR AS LABELSUPEVISOR,
           I.CDVENDEDOR, VD.NMRAZSOCVEN AS NMVENDEDOR, VD.NMRAZSOCVEN AS LABEELVENDEDOR, TO_CHAR(FILOCAVECOTI.DTENTRVENDA, 'DD/MM/YYYY') AS DTENTRVENDA,
           SUM(NVL(I.VRDESITVEND, 0)) AS DESCONTO, SUM(I.QTPRODVEND)  AS QTDE,
           SUM(TRUNC((I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0))) + NVL(I.VRACRITVEND,0),2)) AS VALOR_TOTAL,
           SUM(TRUNC((I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0))) + NVL(I.VRACRITVEND,0) - NVL(I.VRDESITVEND, 0),2)) AS VALOR_VENDIDO
      FROM ITEMVENDA I
      JOIN PRODUTO P
      ON I.CDPRODUTO = P.CDPRODUTO
       AND I.NRORG = P.NRORG
      LEFT JOIN VENDEDOR VD
        ON I.CDVENDEDOR = VD.CDVENDEDOR
       AND I.NRORG = VD.NRORG
      LEFT JOIN OPERADOR OP
        ON I.CDSUPERVDESC = OP.CDOPERADOR
       AND I.NRORG = OP.NRORG
      LEFT JOIN PRODUTO P4
        ON P.CDPRODNIVANTE = P4.CDPRODUTO
       AND P.NRORG = P4.NRORG
      LEFT JOIN PRODUTO P3
        ON P4.CDPRODNIVANTE = P3.CDPRODUTO
       AND P4.NRORG = P3.NRORG
      JOIN (SELECT FILOCAVECO.IDSITUVENDA, FILOCAVECO.NRSEQVENDA, FILOCAVECO.CDCAIXA, FILOCAVECO.NMCAIXA, FILOCAVECO.CDLOJA, FILOCAVECO.NMLOJA, FILOCAVECO.CDFILIAL, FILOCAVECO.CDCONSUMIDOR,
                 FILOCAVECO.NMFILIAL, FILOCAVECO.NRORG, FILOCAVECO.CDPRODTAXASERV, FILOCAVECO.CDTIPOCONS, FILOCAVECO.NMCONSUMIDOR, TC.NMTIPOCONS, FILOCAVECO.DTENTRVENDA, FILOCAVECO.CDCLIENTE
          FROM TIPOCONS TC
          JOIN ( SELECT FILOCAVE.IDSITUVENDA, FILOCAVE.NRSEQVENDA, FILOCAVE.CDCAIXA, FILOCAVE.NMCAIXA, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, FILOCAVE.CDFILIAL, FILOCAVE.CDCONSUMIDOR,
                      FILOCAVE.NMFILIAL, FILOCAVE.NRORG, FILOCAVE.CDPRODTAXASERV, C.CDTIPOCONS, C.NMCONSUMIDOR, FILOCAVE.DTENTRVENDA, FILOCAVE.CDCLIENTE
                   FROM CONSUMIDOR C
                   JOIN (SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, V.CDCONSUMIDOR,
                              FILOCA.NMFILIAL, FILOCA.NRORG, FILOCA.CDPRODTAXASERV, V.DTENTRVENDA, V.CDCLIENTE
                     FROM VENDA V
                     JOIN ( SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG, FILO.CDPRODTAXASERV
                      FROM CAIXA C
                      JOIN ( SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG, L.CDPRODTAXASERV
                           FROM LOJA L
                           JOIN ( SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
                                FROM FILIAL F
                                   WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0) OR (:TCDFILIAL = 'T'))
                                 AND F.NRORG = :NRORG ) FI
                             ON L.CDFILIAL = FI.CDFILIAL
                              AND L.NRORG = FI.NRORG ) FILO
                        ON C.CDFILIAL = FILO.CDFILIAL
                       AND C.CDLOJA = FILO.CDLOJA
                       AND C.NRORG = FILO.NRORG ) FILOCA
                   ON V.CDCAIXA = FILOCA.CDCAIXA
                  AND V.CDLOJA = FILOCA.CDLOJA
                  AND V.CDFILIAL = FILOCA.CDFILIAL
                  AND V.NRORG = FILOCA.NRORG
                    WHERE V.IDSITUVENDA = 'O'
                  AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
                            AND  V.CDCONSUMIDOR IS NOT NULL
                  AND ((INSTR(:CDCLIENTE, V.CDFILIAL||V.CDCLIENTE ) <> 0) OR (:TCDCLIENTE = 'T'))
                  AND ((INSTR(:CDCONSUMIDOR , '_'||V.CDCLIENTE ||V.CDCONSUMIDOR ||'_') <> 0 ) OR (:TCDCONSUMIDOR = 'T'))
                    ) FILOCAVE
                     ON FILOCAVE.CDCONSUMIDOR = C.CDCONSUMIDOR
                    AND FILOCAVE.CDCLIENTE = C.CDCLIENTE
                    AND FILOCAVE.NRORG = C.NRORG
                  WHERE ((INSTR(:CDCLIENTE, FILOCAVE.CDFILIAL||C.CDCLIENTE ) <> 0) OR (:TCDCLIENTE = 'T'))
                AND ((INSTR(:CDCONSUMIDOR , '_'||C.CDCLIENTE ||C.CDCONSUMIDOR ||'_') <> 0 ) OR (:TCDCONSUMIDOR = 'T'))
                AND ((INSTR(:CDTIPOCONS , C.CDTIPOCONS) <> 0 ) OR (:TCDTIPOCONS = 'T'))
                   ) FILOCAVECO
            ON FILOCAVECO.CDTIPOCONS = TC.CDTIPOCONS
               AND FILOCAVECO.NRORG = TC.NRORG
           WHERE ((INSTR(:CDTIPOCONS , TC.CDTIPOCONS) <> 0 ) OR (:TCDTIPOCONS = 'T'))
           ) FILOCAVECOTI
        ON I.NRSEQVENDA = FILOCAVECOTI.NRSEQVENDA
       AND I.CDFILIAL = FILOCAVECOTI.CDFILIAL
       AND I.CDCAIXA = FILOCAVECOTI.CDCAIXA
       AND I.NRORG = FILOCAVECOTI.NRORG
     WHERE I.VRDESITVEND <> '0'
     GROUP BY FILOCAVECOTI.IDSITUVENDA, FILOCAVECOTI.NRSEQVENDA, FILOCAVECOTI.CDCAIXA, FILOCAVECOTI.NMCAIXA, FILOCAVECOTI.CDLOJA, FILOCAVECOTI.NMLOJA, FILOCAVECOTI.CDFILIAL, 
            FILOCAVECOTI.CDCONSUMIDOR, FILOCAVECOTI.NMFILIAL, FILOCAVECOTI.NRORG, FILOCAVECOTI.CDPRODTAXASERV, FILOCAVECOTI.CDTIPOCONS, FILOCAVECOTI.NMCONSUMIDOR, 
            FILOCAVECOTI.NMTIPOCONS, P.CDARVPROD, I.CDPRODUTO, P.NMPRODUTO, FILOCAVECOTI.CDCLIENTE, FILOCAVECOTI.DTENTRVENDA,
            P3.CDARVPROD, P3.CDPRODUTO, P3.NMPRODUTO, I.CDSUPERVDESC, OP.NMOPERADOR, I.CDVENDEDOR, VD.NMRAZSOCVEN
  ";
}